<?php

namespace RxConnexionBundle\Form;

use Doctrine\Common\Persistence\ObjectManager;
use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\Mapping\Entity;
use RxConnexionBundle\Form\DataTransformer\DataTransformer;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormEvent;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\OptionsResolver\OptionsResolver;
use RxConnexionBundle\Entity\AddInventoryEntity;
use RxConnexionBundle\Entity\AddInventoryItemEntity;

class AddInventoryItemForm extends AbstractType
{
    private $manager;

    public function __construct(ObjectManager $manager) {
        $this->manager = $manager;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('action', HiddenType::class, array(
                'mapped' => false,
                'attr' => array(
                    'class' => 'form-action'
                )
            ))
            ->add('addInventory', HiddenType::class, array(
                'attr' => array(
                    'value' => $options['addInventory']
                )
            ))
            ->add('id', HiddenType::class)
            ->add('created_by', HiddenType::class)
            ->add('created_at', HiddenType::class)
            ->add('updated_by', HiddenType::class)
            ->add('updated_at', HiddenType::class)
            ->add('quantity', TextType::class, array(
                'label' => 'Quantity',
                'label_attr' => array(
                    'class' => 'required middle'
                ),
                'required' => true,
                'attr' => array(
                    'class' => 'amount'
                )
            ))
            ->add('price', TextType::class, array(
                'label' => 'Item Price',
                'label_attr' => array(
                    'class' => 'middle'
                ),
                'required' => false,
                'attr' => array(
                    'class' => 'amount'
                )
            ))
            ->add('item', HiddenType::class)
            ->add('location', HiddenType::class)
            ->addEventListener(FormEvents::PRE_SET_DATA, function(FormEvent $event) {

                $form = $event->getForm();
                $data = $event->getData();
                $item = $data->getItem();
                $location = $data->getLocation();

                $form
                    ->add('item_description', TextType::class, array(
                        'mapped' => false,
                        'label' => 'Item',
                        'label_attr' => array(
                            'class' => 'required middle'
                        ),
                        'required' => true,
                        'data' => $item ? $item->getDescription() : '',
                    ))
                    ->add('location_description', TextType::class, array(
                        'mapped' => false,
                        'label' => 'Location',
                        'label_attr' => array(
                            'class' => 'required middle'
                        ),
                        'required' => true,
                        'data' => $location ? $location->getDescription() : '',
                    ));
//                    ->add('item_unit_measurement_id', HiddenType::class, array(
//                        'mapped' => false,
//                        'data' => $this->item_unit_measurement_id
//                    ))
//                    ->add('item_unit_measurement_description', TextType::class, array(
//                        'mapped' => false,
//                        'label' => 'Unit Measurement',
//                        'label_attr' => array(
//                            'class' => 'required middle'
//                        ),
//                        'required' => true,
//                        'data' => $this->item_unit_measurement_description
//                    ));

            });

        $builder->get('addInventory')->addModelTransformer(new DataTransformer($this->manager, 'RxConnexionBundle:AddInventoryEntity', false));
        $builder->get('item')->addModelTransformer(new DataTransformer($this->manager, 'RxConnexionBundle:ItemEntity', false));
        $builder->get('location')->addModelTransformer(new DataTransformer($this->manager, 'RxConnexionBundle:LocationEntity', false));

    }

    public function getBlockPrefix()
    {
        return 'addInventoryItem';
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' 	  => 'RxConnexionBundle\Entity\AddInventoryItemEntity',
            'csrf_protection' => true,
            'csrf_field_name' => '_token',
            // a unique key to help generate the secret token
            'intention'       => 'addInventoryItemEntity_intention',
            'action'          => 'n',
            'addInventory'          => null
        ));
    }
}